const express = require('express');
const router = express.Router();

const adModel = require('../models/ad');

/* GET to get to get to the ad creation form */
router.get('/create', function(req, res, next) {
  res.render('ad_create');
})
.post('/create', function(req, res, next) {
  console.log(req.body);

  //TODO : gérer l'upload de fichier (avec le middleware multiparty par exemple)
  const newAd = new adModel.Ad({
    title: req.body.title,
    type: req.body.type,
    transactionStatus: req.body.transactionStatus,
    price: req.body.price.replace(',', '.'),
    published: req.body.published && true,
    description: req.body.description,
    availabilityDate: req.body.date === '' ? null : req.body.date,
    //pictures: req.body.pictures === '' ? [] : req.body.pictures
  })

  newAd.save()
  .then(value => res.redirect('/ads/view'))
  .catch(reason => {
    console.log(reason);
    res.render('ad_create', reason);
  });
})
.get('/view', function(req, res, next) {
  adModel.Ad.find({ published: true }).exec()
  .then(value => {
    res.render('ad_view', { ads: value });
  })
  .catch(_ => {
    console.log(_);
    res.render('ad_view', { ads: [], errors: { load: 'Un problème est survenu lors du chargement des données' }});
  });
})
.get('/update/:id', function(req, res, next) {
  const id = req.params.id;
  const ad = new adModel.Ad.findOne({ _id: id });

  res.render('ad_create', { ad: ad });
});

/*adModelToAdViewModel = e => {
  return {
    _id: e._id,
    title: e.title,
    type: adModel.AD_TYPE.LANG[e.type.toUpperCase()],
    transactionStatus: adModel.AD_TRANSACTIONSTATUS.LANG[e.transactionStatus.toUpperCase()],
    price: e.price,
    published: e.published,
    description: e.description,
    availabilityDate: e.availabilityDate.toLocaleDateString(),
    pictures: e.pictures,
    questions: e.questions,
  }
}*/

module.exports = router;
